#include "CmdDriver.h"

CmdDriver::CmdDriver(int argc, char **argv){
	parse(argc, argv);
}

void CmdDriver::getHelp(){
	cout << "-it [number, int] Set number of iteratios." << endl;
	cout << "-h Get this help." << endl;
}

void CmdDriver::getProgramInfo(){
	cout << "GlucoseTransporters.exe <Path to bounds file> <Path to SQLite file> [<Params>]" << endl;
	cout << "Type -h for get programm help." << endl;
}

void CmdDriver::parse(int argc, char **argv){
	if (argc < 3){
		cerr << "Must set both of files - bounds and SQLite." << endl;
		getProgramInfo();
		exit(EXIT_FAILURE);
	}

	_params.insert(pair<string, string>("bounds", string(argv[1])));
	_params.insert(pair<string, string>("sql", string(argv[2])));
	
	for (int i = 1; i < argc; ++i){
		if (string(argv[i]).compare("-h") == 0){
			getHelp();
			exit(EXIT_SUCCESS);
		}
		else if (string(argv[i]).compare("-it") == 0){
			_params.insert(pair<string, string>("it", argv[i + 1]));
			i++;
		}
	}
}

string CmdDriver::getParam(string key){
	std::map<string, string>::iterator it;
	it = _params.find(key);
	if (it == _params.end()){
		//cerr << "Pro kli " << key << " nebylo nic nalezeno!" << endl;
		return "";
	}
	else {
		//cout << "Find for key " << key << " is " << it->second << endl;
		return it->second;
	}
}
