#pragma once

#include <vector>
#include <ostream>
#include <cfloat>
#include "Constants.h"
#include "EquationBounds.h"

using namespace std;

// Parametry rovnice 
class EquationData
{
public:
	EquationData();
	EquationData(double p, double cg, double c, double dt, double h, double k);

	// Getters 
	double getP() const { return _p; }
	double getCg() const { return _cg; }
	double getC() const { return _c; }
	double getDt() const { return _dt; }
	double getH() const { return _h; }
	double getK() const { return _k; }
	bool isOutOfRange() const { return _p_out | _cg_out | _c_out | _dt_out | _h_out | _k_out; }
	bool isOutOfRangeP() const { return _p_out; }
	bool isOutOfRangeCg() const { return _cg_out; }
	bool isOutOfRangeC() const { return _c_out; }
	bool isOutOfRangeDt() const { return _dt_out; }
	bool isOutOfRangeH() const { return _h_out; }
	bool isOutOfRangeK() const { return _k_out; }

	double getMetric() const { return _metric; }

	// Setters 
	void setAllParameters(double p,	double cg, double c, double dt, double h, double k);
	void clear();
	void setP(double p);
	void setCg(double cg);
	void setC(double c);
	void setDt(double dt);
	void setH(double h);
	void setK(double k);
	void setMetric(double metric);

private:
	double _metric;
	double _p, _cg, _c, _dt, _h, _k;
	bool _p_out, _cg_out, _c_out, _dt_out, _h_out, _k_out;
};
std::ostream& operator<<(std::ostream &strm, const EquationData &x);
bool operator<(EquationData const & L, EquationData const & R);
