#include "FileDriver.h"


FileDriver::FileDriver(string path) : _path(path) {}

void FileDriver::load(){
	string line;
	ifstream file(_path, ifstream::in);

	if (!file.is_open()) {
		throw "Error, file cannot be opened!";
	}

	while (getline(file, line)){
		parseRow(line);
	}
	file.close();

	for (map<string, double>::iterator it = _data.begin(); it != _data.end(); ++it){
		if (it->first.compare("pmin") == 0)
			EquationBounds::pmin = it->second;
		else if (it->first.compare("pmax") == 0)
			EquationBounds::pmax = it->second;
		else if (it->first.compare("cgmin") == 0)
			EquationBounds::cgmin = it->second;
		else if (it->first.compare("cgmax") == 0)
			EquationBounds::cgmax = it->second;
		else if (it->first.compare("cmin") == 0)
			EquationBounds::cmin = it->second;
		else if (it->first.compare("cmax") == 0)
			EquationBounds::cmax = it->second;
		else if (it->first.compare("dtmin") == 0)
			EquationBounds::dtmin = it->second;
		else if (it->first.compare("dtmax") == 0)
			EquationBounds::dtmax = it->second;
		else if (it->first.compare("hmin") == 0)
			EquationBounds::hmin = it->second;
		else if (it->first.compare("hmax") == 0)
			EquationBounds::hmax = it->second;
		else if (it->first.compare("kmin") == 0)
			EquationBounds::kmin = it->second;
		else if (it->first.compare("kmax") == 0)
			EquationBounds::kmax = it->second;
	}
	EquationBounds::is_default = false;
}

void FileDriver::parseRow(string row){
	int equal_pos;
	double val;
	string key;
	
	if ((unsigned)(equal_pos = row.find("=")) != string::npos && equal_pos != -1){
		key = row.substr(0, equal_pos);
		transform(key.begin(), key.end(), key.begin(), ::tolower);
		val = stod(row.substr(equal_pos + 1, row.length()).c_str());
		_data.insert(pair<string, double>(key, val));
	}
}