#pragma once
#include "EquationData.h"
#include "EquationBounds.h"
#include <algorithm>
#include <random>
#include <chrono>
#include "EquationBounds.h"
#include "SegmentData.h"

using namespace std;

class NealderMead
{
public:
	NealderMead(SegmentData &segment);

	vector<EquationData> getSimplex() { return _simplex; }
	void setSimplexRow(int index, EquationData eq);

	void generateSimplex();
	EquationData generateParams();
	void countAllMetrics(SegmentData &segment);
	double countMetrics(EquationData &params, SegmentData &segment);
	void sort();
	void calculate(SegmentData &segment);

private: 
	vector<EquationData> _simplex;

};
std::ostream& operator<<(std::ostream &strm, const NealderMead &x);
