
#include <iostream>
#include <iomanip>
#include <chrono>

#include "Constants.h"
#include "SqliteDriver.h"
#include "FileDriver.h"
#include "EquationBounds.h"
#include "MeasuredData.h"
#include "SegmentData.h"
#include "EquationData.h"
#include "CmdDriver.h"
#include "NealderMead.h"

// MPI
#include <mpi.h>
#define MASTER_ID 0
void master(int count_process, vector<SegmentData> &segments);
void slave(int aId_node, vector<SegmentData> &segments);
extern int segment_count;


void exit_handler();


double EquationBounds::pmin = P_MIN;
double EquationBounds::pmax = P_MAX;
double EquationBounds::cgmin = CG_MIN;
double EquationBounds::cgmax = CG_MAX;
double EquationBounds::cmin = C_MIN;
double EquationBounds::cmax = C_MAX;
double EquationBounds::dtmin = DT_MIN;
double EquationBounds::dtmax = DT_MAX;
double EquationBounds::hmin = H_MIN;
double EquationBounds::hmax = H_MAX;
double EquationBounds::kmin = K_MIN;
double EquationBounds::kmax = K_MAX;
bool EquationBounds::is_default = true;