#ifndef _MEASUREDDATA_H
#define _MEASUREDDATA_H

#include <sstream>

//One measured row from database
class MeasuredData
{
public:
	MeasuredData();
	MeasuredData(int row_id, double date, double blood, double ist);
	
	// Getters
	int getRowId() const { return _row_id; }
	double getDate() const { return _date; }
	double getBlood() const { return _blood; }
	double getIst() const { return _ist; }

	// Setters
	void setRowId(int row_id);
	void setDate(double date);
	void setBlood(double blood);
	void setIst(double ist);

private:
	//ID in database
	int _row_id;
	//datetime in double format number of days (one day is 1.0)
	double _date;
	//blood glucose concentration [mmol/l]
	double _blood;
	//concentration in the interstitial fluid [mmol/l]
	double _ist;
};
std::ostream& operator<<(std::ostream &strm, const MeasuredData &x);

#endif