#ifndef _NELDER_MEAD_H
#define _NELDER_MEAD_H

#include "Config.h"
#include "EquationData.h"
#include "EquationBounds.h"
#include <algorithm>
#include <random>
#include <chrono>
#include "EquationBounds.h"
#include "SegmentData.h"

using namespace std;

//Nelder-Mead simplex optimization algorithm
class NelderMead
{
public:
	NelderMead(SegmentData &segment);

	vector<EquationData> getSimplex() { return _simplex; }

	//generate simplex: X sets of parameters
	void generateSimplex();
	void countAllMetrics(SegmentData &segment);
	double countMetrics(EquationData &params, SegmentData &segment);
	void sort();
	//executive Nelder-Mead algorithm
	void calculate(SegmentData &segment);

private: 
	//simplex: sets of parameters
	vector<EquationData> _simplex;

};
std::ostream& operator<<(std::ostream &strm, const NelderMead &x);

#endif